package com.engine.htxc.contract.dto;

import java.io.Serializable;
import java.util.List;

/**
 * @Title: ecology-9
 * @Company: 泛微软件
 * @author: K1810050
 * @version: 1.0
 * @CreateDate: 2022/8/23 10:39
 * @Description: 合同详细信息
 * @ModifyLog:
 **/
public class ContractDetailDTO implements Serializable {
    /**
     * 合同名称
     */
    private String contractName;

    /**
     * 对手方
     */
    private List<CounterPartyDTO> counterPartyList;

    /**
     * 产品编码
     */
    private List<String> productCodeList;

    /**
     * 合同正文
     */
    private List<ContractFileDTO> mainFileList;

    /**
     * 合同附件
     */
    private List<ContractFileDTO> attachedFileList;

    /**
     * 印章
     */
    private List<String> seals;

    /**
     * 合同备注
     *
     */
    private String contractComment;

    /**
     * 文本来源 LOCAL 本地上传/NORMAL 标准文本/EXAMPLE 示范文本
     *
     */
    private String textSource;

    /**
     * 未使用范本原因
     *
     */
    private String unusedTextReason;

    /**
     * 起草人工号
     */
    private String userCode;

    /**
     * 起草人部门
     */
    private String userDeptCode;

    /**
     * 自动用印 必填 模板编号
     */
    private String templateNo;

    public String getContractName() {
        return contractName;
    }

    public void setContractName(String contractName) {
        this.contractName = contractName;
    }

    public List<CounterPartyDTO> getCounterPartyList() {
        return counterPartyList;
    }

    public void setCounterPartyList(List<CounterPartyDTO> counterPartyList) {
        this.counterPartyList = counterPartyList;
    }

    public List<String> getProductCodeList() {
        return productCodeList;
    }

    public void setProductCodeList(List<String> productCodeList) {
        this.productCodeList = productCodeList;
    }

    public List<ContractFileDTO> getMainFileList() {
        return mainFileList;
    }

    public void setMainFileList(List<ContractFileDTO> mainFileList) {
        this.mainFileList = mainFileList;
    }

    public List<ContractFileDTO> getAttachedFileList() {
        return attachedFileList;
    }

    public void setAttachedFileList(List<ContractFileDTO> attachedFileList) {
        this.attachedFileList = attachedFileList;
    }

    public List<String> getSeals() {
        return seals;
    }

    public void setSeals(List<String> seals) {
        this.seals = seals;
    }

    public String getContractComment() {
        return contractComment;
    }

    public void setContractComment(String contractComment) {
        this.contractComment = contractComment;
    }

    public String getTextSource() {
        return textSource;
    }

    public void setTextSource(String textSource) {
        this.textSource = textSource;
    }

    public String getUnusedTextReason() {
        return unusedTextReason;
    }

    public void setUnusedTextReason(String unusedTextReason) {
        this.unusedTextReason = unusedTextReason;
    }

    public String getUserCode() {
        return userCode;
    }

    public void setUserCode(String userCode) {
        this.userCode = userCode;
    }

    public String getUserDeptCode() {
        return userDeptCode;
    }

    public void setUserDeptCode(String userDeptCode) {
        this.userDeptCode = userDeptCode;
    }

    public String getTemplateNo() {
        return templateNo;
    }

    public void setTemplateNo(String templateNo) {
        this.templateNo = templateNo;
    }

    @Override
    public String toString() {
        return "ContractDetailDTO{" + "contractName='" + contractName + '\'' + ", counterPartyList=" + counterPartyList
            + ", productCodeList=" + productCodeList + ", mainFileList=" + mainFileList + ", attachedFileList="
            + attachedFileList + ", seals=" + seals + ", contractComment='" + contractComment + '\'' + ", textSource='"
            + textSource + '\'' + ", unusedTextReason='" + unusedTextReason + '\'' + ", userCode='" + userCode + '\''
            + ", userDeptCode='" + userDeptCode + '\'' + ", templateNo='" + templateNo + '\'' + '}';
    }
}
