package com.engine.htxc.contract.dto;

import java.io.Serializable;

/**
 * @Title: ecology-9
 * @Company: 泛微软件
 * @author: K1810050
 * @version: 1.0
 * @CreateDate: 2022/8/23 10:40
 * @Description: 合同文件
 * @ModifyLog:
 **/
public class ContractFileDTO implements Serializable {
    /**
     * 文件名称
     */
    private String fileName;
    /**
     * 文件存储网关
     */
    private String fileId;
    /**
     * 文件后缀
     */
    private String suffix;

    /**
     * 用印方式 枚举值：电子用印,物理用印,物理和电子,不用印
     */
    private String sealMethod;

    /**
     * 电子用印方式 枚举值：电子件,防伪打印件,对手方电子件
     */
    private String esealMethod;
    /**
     * 单双面打印 枚举值：单面打印,双面打印
     */
    private String printBothSide;

    /**
     * 打印份数 用印方式:电子用印方式：防伪打印件时，打印份数赋值给防伪打印份数； 物理和电子方式：打印份数同时赋值给物理用印份数和防伪打印份数
     */
    private Integer printCount;

    /**
     * 物理用印份数 用印方式:物理用印时，打印份数赋值给物理用印份数；
     */
    private Integer physicalSealCount;

    public String getFileName() {
        return fileName;
    }

    public void setFileName(String fileName) {
        this.fileName = fileName;
    }

    public String getFileId() {
        return fileId;
    }

    public void setFileId(String fileId) {
        this.fileId = fileId;
    }

    public String getSuffix() {
        return suffix;
    }

    public void setSuffix(String suffix) {
        this.suffix = suffix;
    }

    public String getSealMethod() {
        return sealMethod;
    }

    public void setSealMethod(String sealMethod) {
        this.sealMethod = sealMethod;
    }

    public String getEsealMethod() {
        return esealMethod;
    }

    public void setEsealMethod(String esealMethod) {
        this.esealMethod = esealMethod;
    }

    public String getPrintBothSide() {
        return printBothSide;
    }

    public void setPrintBothSide(String printBothSide) {
        this.printBothSide = printBothSide;
    }

    public Integer getPrintCount() {
        return printCount;
    }

    public void setPrintCount(Integer printCount) {
        this.printCount = printCount;
    }

    public Integer getPhysicalSealCount() {
        return physicalSealCount;
    }

    public void setPhysicalSealCount(Integer physicalSealCount) {
        this.physicalSealCount = physicalSealCount;
    }

    @Override
    public String toString() {
        return "ContractFileDTO{" + "fileName='" + fileName + '\'' + ", fileId='" + fileId + '\'' + ", suffix='"
            + suffix + '\'' + ", sealMethod='" + sealMethod + '\'' + ", esealMethod='" + esealMethod + '\''
            + ", printBothSide='" + printBothSide + '\'' + ", printCount=" + printCount + ", physicalSealCount="
            + physicalSealCount + '}';
    }
}
