package com.engine.htxc.contract.dto;

import java.io.Serializable;
import java.util.List;

/**
 * @Title: ecology-9
 * @Company: 泛微软件
 * @author: K1810050
 * @version: 1.0
 * @CreateDate: 2022/8/23 10:40
 * @Description: 合同流程数据
 * @ModifyLog:
 **/
public class ContractProcessDTO implements Serializable {
    /**
     * 调用方
     */
    private String sysCode;

    /**
     * 发起类型
     */
    private String moduleCode;
    /**
     * 合同列表
     */
    private List<ContractDetailDTO> contractList;

    /**
     * 合同流程标题
     */
    private String processTitle;
    /**
     * 合同经办人
     */
    private String userCode;
    /**
     * 合同经办人部门编码
     */
    private String userDeptCode;
    /**
     * 联系电话
     */
    private String telephone;

    /**
     * 合同分类
     */
    private String contractCategoryId;

    /**
     * 通知阅读人id集合
     */
    private List<UserDeptInfoDTO> noticeReaderIds;

    /**
     * 内部审核
     */
    private List<UserDeptInfoDTO> internalAuditIds;

    /**
     * 部门领导
     */
    private List<UserDeptInfoDTO> deptHeadIds;

    /**
     * 是否自动用印表示
     */
    private Boolean autoSealFlag;

    public String getSysCode() {
        return sysCode;
    }

    public void setSysCode(String sysCode) {
        this.sysCode = sysCode;
    }

    public String getModuleCode() {
        return moduleCode;
    }

    public void setModuleCode(String moduleCode) {
        this.moduleCode = moduleCode;
    }

    public String getProcessTitle() {
        return processTitle;
    }

    public void setProcessTitle(String processTitle) {
        this.processTitle = processTitle;
    }

    public String getUserCode() {
        return userCode;
    }

    public void setUserCode(String userCode) {
        this.userCode = userCode;
    }

    public String getUserDeptCode() {
        return userDeptCode;
    }

    public void setUserDeptCode(String userDeptCode) {
        this.userDeptCode = userDeptCode;
    }

    public String getTelephone() {
        return telephone;
    }

    public void setTelephone(String telephone) {
        this.telephone = telephone;
    }

    public String getContractCategoryId() {
        return contractCategoryId;
    }

    public void setContractCategoryId(String contractCategoryId) {
        this.contractCategoryId = contractCategoryId;
    }

    public List<UserDeptInfoDTO> getNoticeReaderIds() {
        return noticeReaderIds;
    }

    public void setNoticeReaderIds(List<UserDeptInfoDTO> noticeReaderIds) {
        this.noticeReaderIds = noticeReaderIds;
    }

    public List<UserDeptInfoDTO> getInternalAuditIds() {
        return internalAuditIds;
    }

    public void setInternalAuditIds(List<UserDeptInfoDTO> internalAuditIds) {
        this.internalAuditIds = internalAuditIds;
    }

    public List<UserDeptInfoDTO> getDeptHeadIds() {
        return deptHeadIds;
    }

    public void setDeptHeadIds(List<UserDeptInfoDTO> deptHeadIds) {
        this.deptHeadIds = deptHeadIds;
    }

    public List<ContractDetailDTO> getContractList() {
        return contractList;
    }

    public void setContractList(List<ContractDetailDTO> contractList) {
        this.contractList = contractList;
    }

    public Boolean getAutoSealFlag() {
        return autoSealFlag;
    }

    public void setAutoSealFlag(Boolean autoSealFlag) {
        this.autoSealFlag = autoSealFlag;
    }

    @Override
    public String toString() {
        return "ContractProcessDTO{" + "sysCode='" + sysCode + '\'' + ", moduleCode='" + moduleCode + '\''
            + ", contractList=" + contractList + ", processTitle='" + processTitle + '\'' + ", userCode='" + userCode
            + '\'' + ", userDeptCode='" + userDeptCode + '\'' + ", telephone='" + telephone + '\''
            + ", contractCategoryId='" + contractCategoryId + '\'' + ", noticeReaderIds=" + noticeReaderIds
            + ", internalAuditIds=" + internalAuditIds + ", deptHeadIds=" + deptHeadIds + ", autoSealFlag="
            + autoSealFlag + '}';
    }
}
