package weaver.interfaces.htsc.cus.webservices.jtgl;

import com.thoughtworks.xstream.annotations.XStreamAlias;
import com.thoughtworks.xstream.annotations.XStreamAsAttribute;
import org.apache.commons.lang.StringUtils;

/**
 * 报销输入参数
 *
 * @author Administrator
 */
@XStreamAlias("ROW")
public class InputData {

  @XStreamAsAttribute
  private String DJLX;//	单据类型
  /**
   * 加速#号分割，得到时 去掉#内容
   */
  @XStreamAsAttribute
  private String DJID;//	单据ID（流程OA编号）
  @XStreamAsAttribute
  private String DWBH;//	核算单位编号（报销部门编号）
  @XStreamAsAttribute
  private String DJBH;//	单据编号（流程OA编号）
  @XStreamAsAttribute
  private String DJRQ;//	单据日期 （格式 yyyyMMdd）
  @XStreamAsAttribute
  private String ZY;//	摘要
  @XStreamAsAttribute
  private String FJZS;//	附件张数
  @XStreamAsAttribute
  private String BXBM;//	报销部门（拟稿人部门名称）
  @XStreamAsAttribute
  private String BXR;//	报销人（拟稿人名称）
  @XStreamAsAttribute
  private String FTBM;//	实际分摊部门（编号）
  @XStreamAsAttribute
  private String FTBMMC;//	实际分摊部门（名称）
  @XStreamAsAttribute
  private String FTR;//	实际承担个人（工号）
  @XStreamAsAttribute
  private String FTRYMC;//	实际承担个人（名称）
  @XStreamAsAttribute
  private String FYXM;//	费用项目(投行项目编号)
  @XStreamAsAttribute
  private String FYXMMC;//	费用项目(投行项目)
  @XStreamAsAttribute
  private String JE;//	分摊金额
  @XStreamAsAttribute
  private String SFDW;//	收付款单位
  @XStreamAsAttribute
  private String KHYH;//	开户银行
  @XStreamAsAttribute
  private String YHZH;//	银行账号
  @XStreamAsAttribute
  private String JZFX;//	借贷方向  借=1，贷=2 香港借=D,贷=C
  @XStreamAsAttribute
  private String DQ;//	地区
  @XStreamAsAttribute
  private String ZFFS;//	支付方式
  @XStreamAsAttribute
  private String SY;//	事由
  @XStreamAsAttribute
  private String KJKM;//	会计科目编号
  @XStreamAsAttribute
  private String YSXMBH;//预算项目编号
  @XStreamAsAttribute
  private String YSXMMC;//预算项目名称
  @XStreamAsAttribute
  private String RYLX;//人员类型
  private String voucherdate;//报销日期
  private String accountperiod;//凭证期间
  private String currencycode;//币种
  @XStreamAsAttribute
  private String BH1;//编号1 it项目付款项目编号
  @XStreamAsAttribute
  private String BZ1;//备注1  it项目付款项目名称
  @XStreamAsAttribute
  private String BZ2;//备注2  是否托收业务 1是 0否
  @XStreamAsAttribute
  private String SFQDZ;//是否全电子票
  @XStreamAsAttribute
  private String DJSL;//单据数量
  @XStreamAsAttribute
  private String ZZDJSL;//纸质单据数量
  @XStreamAsAttribute
  private String SFYFP;//是否先付款后发票



  public String getJZFX() {
    return JZFX;
  }

  public void setJZFX(String jZFX) {
    JZFX = jZFX;
  }

  public String getDJLX() {
    return DJLX;
  }

  public void setDJLX(String dJLX) {
    DJLX = dJLX;
  }

  public String getDJID() {
    return DJID;
  }

  public void setDJID(String dJID) {
    DJID = dJID;
  }

  public String getDWBH() {
    return DWBH;
  }

  public void setDWBH(String dWBH) {
    DWBH = dWBH;
  }

  public String getDJBH() {
    return DJBH;
  }

  public void setDJBH(String dJBH) {
    DJBH = dJBH;
  }

  public String getDJRQ() {
    return DJRQ;
  }

  public void setDJRQ(String dJRQ) {
    DJRQ = dJRQ;
  }

  public String getZY() {
    return ZY;
  }

  public void setZY(String zY) {
    ZY = zY;
  }

  public String getFJZS() {
    return FJZS;
  }

  public void setFJZS(String fJZS) {
    FJZS = fJZS;
  }

  public String getBXBM() {
    return BXBM;
  }

  public void setBXBM(String bXBM) {
    BXBM = bXBM;
  }

  public String getBXR() {
    return BXR;
  }

  public void setBXR(String bXR) {
    BXR = bXR;
  }

  public String getFTBM() {
    return FTBM;
  }

  public void setFTBM(String fTBM) {
    FTBM = fTBM;
  }

  public String getFTR() {
    return FTR;
  }

  public void setFTR(String fTR) {
    if (StringUtils.isEmpty(fTR)) {
      FTR = "";
    } else {
      FTR = fTR.replaceAll("(@[a-zA-Z0-9_]+)", "");
    }
  }

  public String getFYXM() {
    return FYXM;
  }

  public void setFYXM(String fYXM) {
    FYXM = fYXM;
  }

  public String getJE() {
    return JE;
  }

  public void setJE(String jE) {
    JE = jE;
  }

  public String getSFDW() {
    return SFDW;
  }

  public void setSFDW(String sFDW) {
    SFDW = sFDW;
  }

  public String getKHYH() {
    return KHYH;
  }

  public void setKHYH(String kHYH) {
    KHYH = kHYH;
  }

  public String getYHZH() {
    return YHZH;
  }

  public void setYHZH(String yHZH) {
    YHZH = yHZH;
  }

  public String getDQ() {
    return DQ;
  }

  public void setDQ(String dQ) {
    DQ = dQ;
  }

  public String getZFFS() {
    return ZFFS;
  }

  public void setZFFS(String zFFS) {
    ZFFS = zFFS;
  }

  public String getSY() {
    return SY;
  }

  public void setSY(String sY) {
    SY = sY;
  }

  public String getKJKM() {
    return KJKM;
  }

  public void setKJKM(String kJKM) {
    KJKM = kJKM;
  }

  public String getFTBMMC() {
    return FTBMMC;
  }

  public void setFTBMMC(String fTBMMC) {
    FTBMMC = fTBMMC;
  }

  public String getFTRYMC() {
    return FTRYMC;
  }

  public void setFTRYMC(String fTRYMC) {
    FTRYMC = fTRYMC;
  }

  public String getFYXMMC() {
    return FYXMMC;
  }

  public void setFYXMMC(String fYXMMC) {
    FYXMMC = fYXMMC;
  }

  public String getYSXMBH() {
    return YSXMBH;
  }

  public void setYSXMBH(String ySXMBH) {
    YSXMBH = ySXMBH;
  }

  public String getYSXMMC() {
    return YSXMMC;
  }

  public void setYSXMMC(String ySXMMC) {
    YSXMMC = ySXMMC;
  }

  public String getRYLX() {
    return RYLX;
  }

  public void setRYLX(String rYLX) {
    RYLX = rYLX;
  }

  public String getVoucherdate() {
    return voucherdate;
  }

  public void setVoucherdate(String voucherdate) {
    this.voucherdate = voucherdate;
  }

  public String getAccountperiod() {
    return accountperiod;
  }

  public void setAccountperiod(String accountperiod) {
    this.accountperiod = accountperiod;
  }

  public String getCurrencycode() {
    return currencycode;
  }

  public void setCurrencycode(String currencycode) {
    this.currencycode = currencycode;
  }

  public String getBH1() {
    return BH1;
  }

  public void setBH1(String bH1) {
    BH1 = bH1;
  }

  public String getBZ1() {
    return BZ1;
  }

  public void setBZ1(String bZ1) {
    BZ1 = bZ1;
  }

  public String getBZ2() {
    return BZ2;
  }

  public void setBZ2(String bZ2) {
    BZ2 = bZ2;
  }

  public String getSFQDZ() {
    return SFQDZ;
  }

  public void setSFQDZ(String SFQDZ) {
    this.SFQDZ = SFQDZ;
  }

  public String getSFYFP() {
    return SFYFP;
  }

  public void setSFYFP(String SFYFP) {
    this.SFYFP = SFYFP;
  }

  public String getDJSL() {
    return DJSL;
  }

  public void setDJSL(String DJSL) {
    this.DJSL = DJSL;
  }

  public String getZZDJSL() {
    return ZZDJSL;
  }

  public void setZZDJSL(String ZZDJSL) {
    this.ZZDJSL = ZZDJSL;
  }
}
